//+------------------------------------------------------------------+
//|                                             ay-MarketProfile.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, ahmad.yani@hotmail.com"
#property link      "ahmad.yani@hotmail.com"




#property indicator_chart_window

extern int        LookBack         = 6;
extern string     TimeframeInfo    = "use W, M or D";
extern string     Timeframe        = "D";
extern int        HistoHeight      = 5;
extern color      HistoColor1      = DimGray;
extern color      HistoColor2      = C'90,90,90';
extern color      OpenColor        = DarkGreen;
extern color      CloseColor       = Peru;
extern color      PocColor         = DimGray;
extern color      VaColor          = C'16,16,16';
extern int        ExtendedPocLines = 5;

string         gsPref = "ay.mp.";
double         fpoint;
int            fdigits;
int            giTf;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {       

   if (Point == 0.001 || Point == 0.00001) 
   { fpoint = Point*10; fdigits = Digits - 1; }
   else 
   { fpoint = Point; fdigits = Digits; }
   
   //default
   
 
   giTf = PERIOD_D1;
   //if (Timeframe != "M") giTf = PERIOD_W1;
   
   if (Timeframe == "D" )
   {
      gsPref = gsPref + "4.0." +Timeframe + "."; 
      giTf = PERIOD_D1;
   }
   else if (Timeframe == "W" )
   {
      gsPref = gsPref + "3.0." +Timeframe + "."; 
      giTf = PERIOD_W1;     
   }
   else if (Timeframe == "M" )   
   {
      gsPref = gsPref + "2.0." +Timeframe + "."; 
      giTf = PERIOD_MN1;     
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   delObjs();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
      
   int nd = 0 , td = 0;
   
   //---create all profile on startup/new tfsource
   //---and then only update the last tfsource profile
   if ( newtfsource() ) { delObjs(); td = LookBack-1; }      

   if (Period() > PERIOD_H4 || Period() < PERIOD_M5) return (-1);      
   
   //---delay 5 seconds
   if (!secondDiff(5)) return(0);
   
   double   historange      = HistoHeight/(MathPow(10,fdigits)); 
   
   //main loop --> week by week, month by month...
   for (nd = td; nd>=0; nd--)
   {
      datetime dttfsource        = iTime(NULL, giTf, nd);
      int      itfsource         = iBarShift(NULL, giTf, dttfsource);
      int      startbar          = iBarShift(NULL, 0, dttfsource);
      double   hh                = iHigh(NULL, giTf, nd);
      double   ll                = iLow (NULL, giTf, nd);
      string   strdttfsource     = TimeToStr(dttfsource,TIME_DATE);
      double   apricestep[][2];  //[][{price, tpo}]        
      double   nhh               = MathCeil(hh/historange) * historange;
      double   nll               = MathCeil(ll/historange) * historange;
      double   profilerange      = nhh - nll;
      double   midprofileprice   = nhh - (0.5 * profilerange);
      double   totaltpo          = 0.0;
      double   tpo70             = 0.0;
      
      if (nhh < hh) nhh += historange;

      //--fix ibarshift on month\week change
      if ( Time[startbar] < dttfsource ) startbar--;
            
      //--open and close arrow
      createArw("o." + strdttfsource, iOpen(NULL, giTf, nd)
         , Time[startbar], 1, OpenColor);
      
      createArw("c." + strdttfsource, iClose(NULL, giTf, nd)
         , Time[startbar], 1, CloseColor);
      
      //---populate price level...
      int     cnt  = 0;
      double  dcnt = 0; 
      color   clr;     
      
      while (nhh >= nll)
      {
         if (MathCeil(dcnt/2) == dcnt/2) clr = HistoColor1;
         else clr = HistoColor2;         
         
         createRect( "rect." + strdttfsource + "." + DoubleToStr(nhh,Digits)
            , nhh,              Time[startbar]
            , nhh - historange, Time[startbar-1]
            , clr );
      
         ArrayResize(apricestep, cnt+1);   
         apricestep [cnt][0] = nhh;
         apricestep [cnt][1] = 0;
 
         nhh -= historange;
         cnt  ++;
         dcnt +=1.0;
      } //end while (nhh >= nll)
            
                  
      //----Counting tpo
      int      countps = cnt
             , i, j
             , maxtpo=0, idxmaxtpo=0;
      double   pricestep;
      for (i=0; i<countps; i++)
      {
         pricestep = apricestep[i][0];
         j = startbar;
         while ( iBarShift(NULL, giTf, Time[j]) == itfsource )
         {            
            if (pricestep > Low[j] && pricestep-historange <= High[j])   
            {
               apricestep[i][1] += 1;  
               totaltpo += 1; 
               //save maxtpo
               if (apricestep[i][1] > maxtpo) 
               {
                  maxtpo    = apricestep[i][1];
                  idxmaxtpo = i;
               }
               
               if (apricestep[i][1] == maxtpo) 
               {
                  // take the closes to the middle of profile range
                  if (   MathAbs(midprofileprice - apricestep[i][0]) 
                       < MathAbs(midprofileprice - apricestep[idxmaxtpo][0]) 
                      )
                  {
                     maxtpo    = apricestep[i][1];
                     idxmaxtpo = i;
                  }
               }
               //end.. save maxtpo
                    
            } //end.. if (price-historange <= High[j] && price >= Low[j])   
            
            j--;
         } //end..  while ( iBarShift(NULL, giTf, Time[j]) == itfsource )
         //----end Counting tpo
         
         //----Update Price Histo / tpo
         int visited = apricestep[i][1];
         
         datetime t2;
         if ( startbar - (visited+1) < 0 ) t2 = Time[0] + (Period() * 60);
         else t2 = Time[ startbar - (visited+1) ];
         
         ObjectSet(gsPref + "rect." + strdttfsource + "." + DoubleToStr(pricestep,Digits)
            , OBJPROP_TIME2
            , t2 );
         //----end Update Price Histo / tpo
         
      }//end for (i=0; i<countps; i++)
      int shiftx = apricestep[idxmaxtpo][1];
      datetime   poct1 = Time[ startbar ];//- shiftx - 1];
      datetime   poct2 = iTime(NULL, giTf, nd-2);

      if (nd <= ExtendedPocLines || poct2<poct1) 
      {
         poct2 = Time[0] + 10*Period()*60;
         createText( "1.0.poc.price."+Timeframe+"#" + nd    
            , poct2 + (3 * Period() * 60)
            , apricestep[idxmaxtpo][0]
            , addStr(Timeframe+".POC "+strdttfsource+" "+DoubleToStr(apricestep[idxmaxtpo][0], fdigits), " ", 60)
            , 8, "Arial Narrow", PocColor
            );                       
      } 
      /* 
      createRect("1.0.poc."+Timeframe+"#" + nd
         , apricestep[idxmaxtpo][0],              poct1
         , apricestep[idxmaxtpo][0] - historange, poct2
         , PocColor); */
      
      createTl("1.1.poc."+Timeframe+"#" + nd
         , poct1, apricestep[idxmaxtpo][0]
         , poct2, apricestep[idxmaxtpo][0]
         , PocColor, STYLE_DASHDOT, 1
         );             
      
      //string cmt ;
      //for (i=0; i<countps; i++)      
         //cmt = StringConcatenate(cmt , i, " price : ", DoubleToStr(apricestep[i][0], fdigits), "  tpo : " , apricestep[i][1], "\n");      
      //Comment(cmt);
      
      tpo70 = 0.7*totaltpo;      
      double tpo = apricestep[idxmaxtpo][1];
      double tpo2upper, tpo2lower;
      int upperidx = 1, lastupperidx = 1; 
      int loweridx = 1, lastloweridx = 1; 
      
      //Print("tpo ", tpo, " 70% tpo : ", tpo70);
      //continue;
      //int loop=0;
      while (tpo <= tpo70)
      {
         //if (loop>100) break;
         
         double utpo1 = apricestep[ idxmaxtpo-upperidx ][1];
         double ltpo1 = apricestep[ idxmaxtpo+loweridx ][1];
         double utpo2 = apricestep[ idxmaxtpo-(upperidx+1) ][1];
         double ltpo2 = apricestep[ idxmaxtpo+(loweridx+1) ][1];
                           
         if ( utpo1 >= ltpo1 && tpo + utpo1 >= tpo70 )
         {
            lastupperidx = upperidx;
            tpo += utpo1;
            //Print("tpo 1 U", tpo);
            break;
         }
         else 
         if ( ltpo1 > utpo1 && tpo + ltpo1 >= tpo70 )
         {
            lastloweridx = loweridx;
            tpo += ltpo1;
            //Print("tpo 1 L", tpo);
            break;         
         }
         
         tpo2upper = utpo1 + utpo2;
         tpo2lower = ltpo1 + ltpo2;
                           
         if (tpo2upper >= tpo2lower)
         {
            lastupperidx = upperidx+1;
            if (idxmaxtpo-lastupperidx < 0) lastupperidx--;
            upperidx +=2;
            tpo += tpo2upper;
            //Print("price@upper ", apricestep[ idxmaxtpo-(lastupperidx) ][0], " tpo ", tpo);
         }
         else
         {
            lastloweridx = loweridx+1;
            if (idxmaxtpo+lastloweridx > countps-1) lastloweridx--;
            loweridx +=2;
            tpo += tpo2lower;        
            //Print("price@lower ", apricestep[ idxmaxtpo+(lastloweridx) ][0], " tpo ", tpo);
         }         
         
         //loop++;
      }
      
      double vah = apricestep[ idxmaxtpo-(lastupperidx) ][0];
      double val = apricestep[ idxmaxtpo+(lastloweridx) ][0];
      /*
      cmt = StringConcatenate(cmt , "totaltpo : ", totaltpo, " 70% tpo : ", tpo70, "\n");
      cmt = StringConcatenate(cmt ,  "va-tpo :", tpo
            , " vah :",    vah
            , " val :",    val
      );
      Comment(cmt);
      */
      datetime dtva1 = Time[startbar];
      datetime dtva2 = iTime(NULL, giTf, nd-1);
      if (dtva2<dtva1) dtva2 = Time[0] + 10*Period()*60;
      //fix weekly open time on lower time frame...
      if ( Time[ iBarShift(NULL,0,dtva2) ] < dtva2 )             
         if (nd != 0) dtva2 = Time[ iBarShift(NULL,0,dtva2) - 1];
         
      int      argb[3];
      intToRGB(VaColor, argb);
      
      int iclr     = 0;
      double va    = vah;
      int idxuva   = idxmaxtpo-lastupperidx;
      int idxlva   = idxmaxtpo+lastloweridx;      
      int idxmidva = idxuva + MathCeil((idxlva-idxuva)/2);
      //Print ("idxuva ",   idxuva, " idxlva ", idxlva,  " idxmidva ", idxmidva, " ", (idxlva-idxuva)/2);
      for (i=idxuva; i<idxmidva; i++)
      {
         shiftx = apricestep[i][1]+1;
         dtva1 = Time[startbar - shiftx];
         if (dtva1 < Time[startbar]) dtva1 = Time[0] + Period()*60;
         createRect("0.0.0.va."+i+"."+Timeframe+"#" + nd
            , va, dtva1 //Time[startbar - shiftx] //Time[startbar - shiftx]//dtva1
            , va-historange, dtva2
            , RGB(argb[0]+iclr, argb[1]+iclr, argb[2]+iclr)
            );
            
         va -= historange;
         iclr +=4;
         
      }
      
      for (i=idxmidva; i<(idxlva); i++)
      {
         //Print(idxmaxtpo, " i", i);
         shiftx = apricestep[i][1]+1;
         dtva1 = Time[startbar - shiftx];
         if (dtva1 < Time[startbar]) dtva1 = Time[0] + Period()*60;
         createRect("0.0.0.va."+i+"."+Timeframe+"#" + nd
            , va, dtva1 //Time[startbar - shiftx] //dtva1
            , va-historange, dtva2
            , RGB(argb[0]+iclr, argb[1]+iclr, argb[2]+iclr)
            );
            
         va -= historange;
         iclr -=4;
         
      }   
      iclr +=16;   
      shiftx = apricestep[idxuva][1]+1;
      dtva1 = Time[startbar - shiftx];
      if (dtva1 < Time[startbar]) dtva1 = Time[0] + Period()*60;      
      createTl("1.0.vah."+Timeframe+"#" + nd
         , dtva1, vah
         , dtva2, vah
         , RGB(argb[0]+iclr, argb[1]+iclr, argb[2]+iclr), STYLE_DASHDOT,1 ); 
      
      shiftx = apricestep[idxlva][1]+1;
      dtva1 = Time[startbar - shiftx];
      if (dtva1 < Time[startbar]) dtva1 = Time[0] + Period()*60;         
      createTl("1.0.val."+Timeframe+"#" + nd
         , dtva1, val
         , dtva2, val
         , RGB(argb[0]+iclr, argb[1]+iclr, argb[2]+iclr), STYLE_DASHDOT,1 );                
      /*    
      createRect("0.0.0.va."+Timeframe+"#" + nd
         , vah, dtva1
         , val, dtva2
         , VaColor);
      */
   }//end for (nd = td; nd>=0; nd--)

   return(0);
}
  
//+------------------------------------------------------------------+
//|add char at beginning or end of text                              |
//+------------------------------------------------------------------+
string addStr(string str, string char, int maxlength, bool atbeginning = true)
{
   int l = maxlength - StringLen(str);
   for (int i=0; i<l; i++)
   {
      if (atbeginning) str = char + str;
      else str = str + char;
   }
      
   return(str);
}  
//+------------------------------------------------------------------+
//| createRect                                                       |
//+------------------------------------------------------------------+   
void createRect(string objname, double p1, datetime t1, double p2, datetime t2, color clr, bool back=true)
{

   objname = gsPref + objname;
   if(ObjectFind(objname) != 0)    
      ObjectCreate(objname, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   
   ObjectSet(objname, OBJPROP_PRICE1, p1);
   ObjectSet(objname, OBJPROP_TIME1,  t1);
   ObjectSet(objname, OBJPROP_PRICE2, p2);
   ObjectSet(objname, OBJPROP_TIME2,  t2);
   ObjectSet(objname, OBJPROP_COLOR,  clr);
   ObjectSet(objname, OBJPROP_BACK,   back);
}  
//+------------------------------------------------------------------+
//| createArw                                                        |
//+------------------------------------------------------------------+ 
void createArw(string objname, double p1, datetime t1, int ac, 
   color clr)
{
   objname = gsPref + objname;
   if(ObjectFind(objname) != 0)    
      ObjectCreate(objname, OBJ_ARROW, 0, 0, 0, 0, 0);
   
   ObjectSet(objname, OBJPROP_PRICE1, p1);
   ObjectSet(objname, OBJPROP_TIME1,  t1);  
   ObjectSet(objname, OBJPROP_ARROWCODE,  ac);  
   ObjectSet(objname, OBJPROP_COLOR,  clr);  
   
}
//+------------------------------------------------------------------+
//| createText                                                       |
//+------------------------------------------------------------------+
void createText(string name, datetime t, double p, string text
   , int size=8, string font="Arial", color c=White)
{
   name = gsPref + name;
   
   if (ObjectFind(name) != 0)
      ObjectCreate (name,OBJ_TEXT,0,0,0);
   
   ObjectSet    (name,OBJPROP_TIME1, t);
   ObjectSet    (name,OBJPROP_PRICE1,p);
   ObjectSetText(name,text,size,font,c);

}
//+------------------------------------------------------------------+
//| createTl                                                         |
//+------------------------------------------------------------------+ 
void createTl(string tlname, datetime t1, double v1, datetime t2, double v2, 
            color tlColor, int style = STYLE_DASHDOT, int width = 1, string desc="")
{
   tlname = gsPref + tlname;
   if(ObjectFind(tlname) != 0)
   {
      ObjectCreate(
            tlname
            , OBJ_TREND
            , 0
            , t1
            , v1
            , t2
            , v2
            );      
   }else
   {
      ObjectMove(tlname, 0, t1, v1);   
      ObjectMove(tlname, 1, t2, v2);
   }
   ObjectSet(tlname, OBJPROP_COLOR, tlColor);
   ObjectSet(tlname, OBJPROP_RAY, false);
   ObjectSet(tlname, OBJPROP_STYLE, style);
   ObjectSet(tlname, OBJPROP_WIDTH, width);
   ObjectSetText(tlname, desc);
} 

//+------------------------------------------------------------------+
//| newtfsource                                                           |
//+------------------------------------------------------------------+
bool newtfsource()
{
 static int Lasttfsource;
 int Currtfsource = iTime(NULL, giTf, 0);//Timetfsource(Time[0]);
 
 if(Lasttfsource!=Currtfsource)
 {
   Lasttfsource=Currtfsource;
   return (true);
 }
   return(false);
}
//+------------------------------------------------------------------+
//| newBar                                                           |
//+------------------------------------------------------------------+   
/*
bool newBar()
{
 static datetime LastBar;
 int CurrBar = Time[0];
 
 if(LastBar!=CurrBar)
 {
   LastBar=CurrBar;
   return (true);
 }
 
 return(false);    
}  
*/  
//+------------------------------------------------------------------+
//| secondDiff                                                       |
//+------------------------------------------------------------------+ 
bool secondDiff(int sec = 10)
{
   static datetime lasttime ;
   int diff = TimeCurrent() - lasttime ;

   if (diff > sec )
   {
      lasttime = TimeCurrent();
      return (true);
   }
   
   return (false);
   
}  

//+------------------------------------------------------------------+
//| delObjs function                                                 |
//+------------------------------------------------------------------+
void delObjs(string s="")
{
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if (StringSubstr(name,0,StringLen(gsPref)) == gsPref) 
      {
         if (StringLen(s) == 0) ObjectDelete(name); 
         else
         {
            if (StringFind(s, name, 0) >=0) ObjectDelete(name); 
         }
      }
   }   
} 

//+------------------------------------------------------------------+
//| convert red, green and blue values to color                      |
//+------------------------------------------------------------------+
int RGB(int red_value,int green_value,int blue_value)
{
   //---- check parameters
   if(red_value<0)     red_value=0;
   if(red_value>255)   red_value=255;
   if(green_value<0)   green_value=0;
   if(green_value>255) green_value=255;
   if(blue_value<0)    blue_value=0;
   if(blue_value>255)  blue_value=255;
   //----
   green_value<<=8;
   blue_value<<=16;
   return(red_value+green_value+blue_value);
}
  
void intToRGB(int clr, int &argb[] )
{   
   int red   = (clr % 0x1000000 / 0x10000);  
   int green = (clr % 0x10000 / 0x100);  
   int blue  = (clr % 0x100); 

   argb[0] = red;
   argb[1] = green;
   argb[2] = blue;
   //Print("red ", red, " green ", green, " blue ", blue);
}  
//+------------------------------------------------------------------+